// THE HOVGAARD KLAN
// PROJECT: HOVTEXT
//---------------------------------------------------------------------------
// NOTES........ :
// The TFileType-class describes a "link-type", and the TFileTypes
// is the collection of "link-types" (pre- & userdefined)
// used in the setup.
//
//---------------------------------------------------------------------------

#ifndef filetypesH
#define filetypesH
//---------------------------------------------------------------------------
#include <string>
#include <vector>
#include "lang.h"

class TFileType
{
  std::string name, wildcard;
  TextEnum textno;

public:
  TFileType();
  TFileType(std::string n, std::string w);
  TFileType(TextEnum  n, std::string w);
  std::string Name() const;
  const std::string &Wildcard() const;
  bool Match(std::string s) const;
  void GetStrs(std::vector<std::string> &v) const;
  void Edit(std::string n, std::string w);
  bool UserDefined() const;
  bool RegEx() const;
};

class TFileTypes
{
  std::vector<TFileType> types;
  unsigned selected;
public:
  TFileTypes();
  const TFileType &operator[](unsigned i) const;
  void Defaults();
  unsigned Size() const;
  unsigned Selected() const;
  void Select(unsigned i);
  bool Match(std::string s) const;
  void GetStrs(std::vector<std::string> &v) const;

  void Add(TFileType t);
  void Remove(unsigned i);
};

extern TFileTypes FileTypes;
#endif
