// THE HOVGAARD KLAN
// PROJECT: HOVTEXT
//---------------------------------------------------------------------------
// NOTES........ :
// Contains all the program text in different languages.
// And the implementation of the TLangNotifier-class, a mechanism
// that allows for Form and other classes to be notified when
// the program-language is changed.
//
//---------------------------------------------------------------------------

#ifndef langH
#define langH
#include <vcl.h>
#pragma hdrstop

#include <vector>

enum TextEnum {TE_LangName, TE_Inactive, TE_Active, TE_Exit, TE_About, TE_Options, TE_OK,
TE_Hotkey, TE_Cancel,TE_StartSetting,TE_LastSetting, TE_Uninstall,
TE_UninstallConfirm,TE_HotkeyFunction,TE_ConvertNow,TE_ToggleActive,
TE_StripWS,TE_StripCR,TE_StartWWin, TE_OnlyCopyLinks,
TE_OnlineHelp,TE_Lang, TE_AutoLang, TE_LinkType,
TE_All, TE_Pictures, TE_Movies,TE_Email,TE_Web,TE_Music,TE_FTP,TE_Archives,TE_EmbedPictures,
TE_General, TE_LinkTypes,TE_Add, TE_Delete,TE_Name,TE_Wildcard,
TE_CantDeletePredefined,
TE_History,TE_HistoryEnable, TE_HistoryLines, TE_HistoryTime,
TE_WelcomeCaption,TE_WelcomeText,
TE_RemoveDoubleLines, TE_LinkCopying
};

short LangId2idx(WORD langid);
WORD Name2LangId(AnsiString name);

AnsiString LangText(TextEnum t);
const std::vector<AnsiString>& LangList();

class TLangChangeNotify
{
public:
	virtual void LangChange()=0;
};

class TLangNotifier
{
   std::vector <TLangChangeNotify *> Clients;
public:
   void AddLangNotify(TLangChangeNotify *n);
   void RemoveLangNotify(TLangChangeNotify *n);
   void LangChange();
};
extern TLangNotifier LangNotifier;



//---------------------------------------------------------------------------
#endif
